<?php
/**
 * The style "default" of the Widget "Contacts"
 *
 * @package WordPress
 * @subpackage ThemeREX Addons
 * @since v1.6.10
 */

$args = get_query_var('trx_addons_args_widget_contacts');
extract($args);
		
// Before widget (defined by themes)
trx_addons_show_layout($before_widget);
			
// Widget title if one was input (before and after defined by themes)
trx_addons_show_layout($title, $before_title, $after_title);
	
// Widget body
if (!empty($logo)) {
	?><div class="contacts_logo"><?php echo trim($logo); ?></div><?php
}
if (!empty($description)) {
	?><div class="contacts_description"><?php echo wpautop($description); ?></div><?php
}
if (!empty($address) || !empty($phone) || !empty($email)) {
	?><div class="contacts_info"><?php
		if (!empty($phone) || !empty($email)) {
			?><div class="contacts_right"><?php
			if (!empty($email)) {
				?><span class="contacts_email"><a href="mailto:<?php echo $email; ?>"><?php echo trim($email); ?></a></span><?php
			}
			if (!empty($phone)) {
				?><span class="contacts_phone"><a href="tel:<?php echo $phone; ?>"><?php echo trim($phone); ?></a></span><?php
			}
			?></div><?php
		}
		if (!empty($address)) {
			?><div class="contacts_left"><span class="contacts_address"><?php echo str_replace('|', "<br>", $address); ?></span></div><?php
		}
	?></div><?php
}

// Social icons
if ( $socials && ($output = trx_addons_get_socials_links()) != '') {
	?><div class="contacts_socials socials_wrap"><?php trx_addons_show_layout($output); ?></div><?php
}

// Custom content
if ( !empty($content) ) {
	?><div class="contacts_content"><?php trx_addons_show_layout($content); ?></div><?php
}
	
// After widget (defined by themes)
trx_addons_show_layout($after_widget);
?>