<?php
/* Date & Time Picker support functions
------------------------------------------------------------------------------- */

// Theme init priorities:
// 9 - register other filters (for installer, etc.)
if ( ! function_exists( 'wisemove_date_time_picker_field_theme_setup9' ) ) {
	add_action( 'after_setup_theme', 'wisemove_date_time_picker_field_theme_setup9', 9 );
	function wisemove_date_time_picker_field_theme_setup9() {
		if ( is_admin() ) {
			add_filter( 'wisemove_filter_tgmpa_required_plugins', 'wisemove_date_time_picker_field_tgmpa_required_plugins', 8 );
		}
	}
}

// Filter to add in the required plugins list
if ( ! function_exists( 'wisemove_date_time_picker_field_tgmpa_required_plugins' ) ) {
    function wisemove_date_time_picker_field_tgmpa_required_plugins( $list = array() ) {
	    if ( in_array( 'date-time-picker-field', wisemove_storage_get( 'required_plugins' ) ) ) {
		    $list[] = array(
			    'name' 		=> esc_html__('Date Picker by Input WP', 'wisemove'),
			    'slug'     => 'date-time-picker-field',
			    'required' => false,
		    );
	    }
        return $list;
    }
}

// Check if this plugin installed and activated
if ( ! function_exists( 'wisemove_exists_date_time_picker_field' ) ) {
    function wisemove_exists_date_time_picker_field() {
        return class_exists( 'CMoreira\\Plugins\\DateTimePicker\\Init' );
    }
}

// Set plugin's specific importer options
if ( !function_exists( 'wisemove_date_time_picker_field_importer_set_options' ) ) {
    add_filter( 'trx_addons_filter_importer_options',	'wisemove_date_time_picker_field_importer_set_options' );
    function wisemove_date_time_picker_field_importer_set_options($options=array()) {
            if (is_array($options)) {
                $options['additional_options'][] = 'dtpicker';
            }
        return $options;
    }
}