<?php
/* ThemeREX Updater support functions
------------------------------------------------------------------------------- */


// Theme init priorities:
// 9 - register other filters (for installer, etc.)
if ( ! function_exists( 'wisemove_trx_updater_theme_setup9' ) ) {
    add_action( 'after_setup_theme', 'wisemove_trx_updater_theme_setup9', 9 );
    function wisemove_trx_updater_theme_setup9() {
        if ( is_admin() ) {
            add_filter( 'wisemove_filter_tgmpa_required_plugins', 'wisemove_trx_updater_tgmpa_required_plugins', 8 );
        }
    }
}


// Filter to add in the required plugins list
if ( ! function_exists( 'wisemove_trx_updater_tgmpa_required_plugins' ) ) {
    
    function wisemove_trx_updater_tgmpa_required_plugins( $list = array() ) {
        if (in_array('trx_updater', wisemove_storage_get('required_plugins'))) {
            $path = wisemove_get_file_dir( 'plugins/trx_updater/trx_updater.zip' );
                $list[] = array(

                    'name' 		=> esc_html__('ThemeREX Updater', 'wisemove'),
                    'slug'     => 'trx_updater',
                    'version'  => '2.0.0',
                    'source'   => ! empty( $path ) ? $path : 'upload://trx_updater.zip',
                    'required' => false,
                );

        }
        return $list;
    }
}
