<?php
/**
 * Generate custom CSS
 *
 * @package WordPress
 * @subpackage WISEMOVE
 * @since WISEMOVE 1.0
 */


			
// Additional (calculated) theme-specific colors
// Attention! Don't forget setup custom colors also in the theme.customizer.color-scheme.js
if (!function_exists('wisemove_customizer_add_theme_colors')) {
	function wisemove_customizer_add_theme_colors($colors) {
		if (substr($colors['text'], 0, 1) == '#') {
			$colors['bg_color_0']  = wisemove_hex2rgba( $colors['bg_color'], 0 );
			$colors['bg_color_02']  = wisemove_hex2rgba( $colors['bg_color'], 0.2 );
			$colors['bg_color_07']  = wisemove_hex2rgba( $colors['bg_color'], 0.7 );
			$colors['bg_color_08']  = wisemove_hex2rgba( $colors['bg_color'], 0.8 );
			$colors['bg_color_09']  = wisemove_hex2rgba( $colors['bg_color'], 0.9 );
			$colors['alter_bg_color_07']  = wisemove_hex2rgba( $colors['alter_bg_color'], 0.7 );
			$colors['alter_bg_color_04']  = wisemove_hex2rgba( $colors['alter_bg_color'], 0.4 );
			$colors['alter_bg_color_02']  = wisemove_hex2rgba( $colors['alter_bg_color'], 0.2 );
			$colors['alter_bd_color_02']  = wisemove_hex2rgba( $colors['alter_bd_color'], 0.2 );
			$colors['text_dark_07']  = wisemove_hex2rgba( $colors['text_dark'], 0.7 );
			$colors['text_link_02']  = wisemove_hex2rgba( $colors['text_link'], 0.2 );
			$colors['text_link_07']  = wisemove_hex2rgba( $colors['text_link'], 0.7 );
			$colors['text_dark_008']  = wisemove_hex2rgba( $colors['text_dark'], 0.08 );
			$colors['text_dark_02']  = wisemove_hex2rgba( $colors['text_dark'], 0.2 );
			$colors['input_bg_color_08']  = wisemove_hex2rgba( $colors['input_bg_color'], 0.8 );
		} else {
			$colors['bg_color_0'] = '{{ data.bg_color_0 }}';
			$colors['bg_color_02'] = '{{ data.bg_color_02 }}';
			$colors['bg_color_07'] = '{{ data.bg_color_07 }}';
			$colors['bg_color_08'] = '{{ data.bg_color_08 }}';
			$colors['bg_color_09'] = '{{ data.bg_color_09 }}';
			$colors['alter_bg_color_07'] = '{{ data.alter_bg_color_07 }}';
			$colors['alter_bg_color_04'] = '{{ data.alter_bg_color_04 }}';
			$colors['alter_bg_color_02'] = '{{ data.alter_bg_color_02 }}';
			$colors['alter_bd_color_02'] = '{{ data.alter_bd_color_02 }}';
			$colors['text_dark_07'] = '{{ data.text_dark_07 }}';
			$colors['text_link_02'] = '{{ data.text_link_02 }}';
			$colors['text_link_07'] = '{{ data.text_link_07 }}';
			$colors['text_dark_008'] = '{{ data.text_dark_008 }}';
			$colors['text_dark_02'] = '{{ data.text_dark_02 }}';
			$colors['input_bg_color_08'] = '{{ data.input_bg_color_08 }}';
		}
		return $colors;
	}
}


			
// Additional theme-specific fonts rules
// Attention! Don't forget setup fonts rules also in the theme.customizer.color-scheme.js
if (!function_exists('wisemove_customizer_add_theme_fonts')) {
	function wisemove_customizer_add_theme_fonts($fonts) {
		$rez = array();	
		foreach ($fonts as $tag => $font) {
			if (substr($font['font-family'], 0, 2) != '{{') {
				$rez[$tag.'_font-family'] 		= !empty($font['font-family']) && !wisemove_is_inherit($font['font-family'])
														? 'font-family:' . trim($font['font-family']) . ';' 
														: '';
				$rez[$tag.'_font-size'] 		= !empty($font['font-size']) && !wisemove_is_inherit($font['font-size'])
														? 'font-size:' . wisemove_prepare_css_value($font['font-size']) . ";"
														: '';
				$rez[$tag.'_line-height'] 		= !empty($font['line-height']) && !wisemove_is_inherit($font['line-height'])
														? 'line-height:' . trim($font['line-height']) . ";"
														: '';
				$rez[$tag.'_font-weight'] 		= !empty($font['font-weight']) && !wisemove_is_inherit($font['font-weight'])
														? 'font-weight:' . trim($font['font-weight']) . ";"
														: '';
				$rez[$tag.'_font-style'] 		= !empty($font['font-style']) && !wisemove_is_inherit($font['font-style'])
														? 'font-style:' . trim($font['font-style']) . ";"
														: '';
				$rez[$tag.'_text-decoration'] 	= !empty($font['text-decoration']) && !wisemove_is_inherit($font['text-decoration'])
														? 'text-decoration:' . trim($font['text-decoration']) . ";"
														: '';
				$rez[$tag.'_text-transform'] 	= !empty($font['text-transform']) && !wisemove_is_inherit($font['text-transform'])
														? 'text-transform:' . trim($font['text-transform']) . ";"
														: '';
				$rez[$tag.'_letter-spacing'] 	= !empty($font['letter-spacing']) && !wisemove_is_inherit($font['letter-spacing'])
														? 'letter-spacing:' . trim($font['letter-spacing']) . ";"
														: '';
				$rez[$tag.'_margin-top'] 		= !empty($font['margin-top']) && !wisemove_is_inherit($font['margin-top'])
														? 'margin-top:' . wisemove_prepare_css_value($font['margin-top']) . ";"
														: '';
				$rez[$tag.'_margin-bottom'] 	= !empty($font['margin-bottom']) && !wisemove_is_inherit($font['margin-bottom'])
														? 'margin-bottom:' . wisemove_prepare_css_value($font['margin-bottom']) . ";"
														: '';
			} else {
				$rez[$tag.'_font-family']		= '{{ data["'.$tag.'_font-family"] }}';
				$rez[$tag.'_font-size']			= '{{ data["'.$tag.'_font-size"] }}';
				$rez[$tag.'_line-height']		= '{{ data["'.$tag.'_line-height"] }}';
				$rez[$tag.'_font-weight']		= '{{ data["'.$tag.'_font-weight"] }}';
				$rez[$tag.'_font-style']		= '{{ data["'.$tag.'_font-style"] }}';
				$rez[$tag.'_text-decoration']	= '{{ data["'.$tag.'_text-decoration"] }}';
				$rez[$tag.'_text-transform']	= '{{ data["'.$tag.'_text-transform"] }}';
				$rez[$tag.'_letter-spacing']	= '{{ data["'.$tag.'_letter-spacing"] }}';
				$rez[$tag.'_margin-top']		= '{{ data["'.$tag.'_margin-top"] }}';
				$rez[$tag.'_margin-bottom']		= '{{ data["'.$tag.'_margin-bottom"] }}';
			}
		}
		return $rez;
	}
}


// Return CSS with custom colors and fonts
if (!function_exists('wisemove_customizer_get_css')) {

	function wisemove_customizer_get_css($colors=null, $fonts=null, $remove_spaces=true, $only_scheme='') {

		$css = array(
			'fonts' => '',
			'colors' => ''
		);
		
		// Prepare fonts
		if ($fonts === null) {
			$fonts = wisemove_get_theme_fonts();
		}
		
		if ($fonts) {

			// Make theme-specific fonts rules
			$fonts = wisemove_customizer_add_theme_fonts($fonts);

			$rez = array();
			$rez['fonts'] = <<<CSS

body {
	{$fonts['p_font-family']}
	{$fonts['p_font-size']}
	{$fonts['p_font-weight']}
	{$fonts['p_font-style']}
	{$fonts['p_line-height']}
	{$fonts['p_text-decoration']}
	{$fonts['p_text-transform']}
	{$fonts['p_letter-spacing']}
}
p, ul, ol, dl, blockquote, address {
	{$fonts['p_margin-top']}
	{$fonts['p_margin-bottom']}
}

h1 {
	{$fonts['h1_font-family']}
	{$fonts['h1_font-size']}
	{$fonts['h1_font-weight']}
	{$fonts['h1_font-style']}
	{$fonts['h1_line-height']}
	{$fonts['h1_text-decoration']}
	{$fonts['h1_text-transform']}
	{$fonts['h1_letter-spacing']}
	{$fonts['h1_margin-top']}
	{$fonts['h1_margin-bottom']}
}
h2 {
	{$fonts['h2_font-family']}
	{$fonts['h2_font-size']}
	{$fonts['h2_font-weight']}
	{$fonts['h2_font-style']}
	{$fonts['h2_line-height']}
	{$fonts['h2_text-decoration']}
	{$fonts['h2_text-transform']}
	{$fonts['h2_letter-spacing']}
	{$fonts['h2_margin-top']}
	{$fonts['h2_margin-bottom']}
}
h3 {
	{$fonts['h3_font-family']}
	{$fonts['h3_font-size']}
	{$fonts['h3_font-weight']}
	{$fonts['h3_font-style']}
	{$fonts['h3_line-height']}
	{$fonts['h3_text-decoration']}
	{$fonts['h3_text-transform']}
	{$fonts['h3_letter-spacing']}
	{$fonts['h3_margin-top']}
	{$fonts['h3_margin-bottom']}
}
h4 {
	{$fonts['h4_font-family']}
	{$fonts['h4_font-size']}
	{$fonts['h4_font-weight']}
	{$fonts['h4_font-style']}
	{$fonts['h4_line-height']}
	{$fonts['h4_text-decoration']}
	{$fonts['h4_text-transform']}
	{$fonts['h4_letter-spacing']}
	{$fonts['h4_margin-top']}
	{$fonts['h4_margin-bottom']}
}
h5 {
	{$fonts['h5_font-family']}
	{$fonts['h5_font-size']}
	{$fonts['h5_font-weight']}
	{$fonts['h5_font-style']}
	{$fonts['h5_line-height']}
	{$fonts['h5_text-decoration']}
	{$fonts['h5_text-transform']}
	{$fonts['h5_letter-spacing']}
	{$fonts['h5_margin-top']}
	{$fonts['h5_margin-bottom']}
}
h6 {
	{$fonts['h6_font-family']}
	{$fonts['h6_font-size']}
	{$fonts['h6_font-weight']}
	{$fonts['h6_font-style']}
	{$fonts['h6_line-height']}
	{$fonts['h6_text-decoration']}
	{$fonts['h6_text-transform']}
	{$fonts['h6_letter-spacing']}
	{$fonts['h6_margin-top']}
	{$fonts['h6_margin-bottom']}
}

input[type="text"],
input[type="number"],
input[type="email"],
input[type="tel"],
input[type="date"],
input[type="search"],
input[type="password"],
textarea,
textarea.wp-editor-area,
.select_container,
select,
.select_container select {
	{$fonts['input_font-family']}
	{$fonts['input_font-size']}
	{$fonts['input_font-weight']}
	{$fonts['input_font-style']}
	{$fonts['input_line-height']}
	{$fonts['input_text-decoration']}
	{$fonts['input_text-transform']}
	{$fonts['input_letter-spacing']}
}

button:not(.wp-block-search__button),
input[type="button"],
input[type="reset"],
input[type="submit"],
.theme_button,
.gallery_preview_show .post_readmore,
.more-link,
.wisemove_tabs .wisemove_tabs_titles li a {
	{$fonts['button_font-family']}
	{$fonts['button_font-size']}
	{$fonts['button_font-weight']}
	{$fonts['button_font-style']}
	{$fonts['button_line-height']}
	{$fonts['button_text-decoration']}
	{$fonts['button_text-transform']}
	{$fonts['button_letter-spacing']}
}

.top_panel .slider_engine_revo .slide_title {
	{$fonts['h1_font-family']}
}

blockquote,
mark, ins,
.logo_text,
.post_price.price,
.theme_scroll_down {
	{$fonts['h5_font-family']}
}

.post_meta {
	{$fonts['info_font-family']}
	{$fonts['info_font-size']}
	{$fonts['info_font-weight']}
	{$fonts['info_font-style']}
	{$fonts['info_line-height']}
	{$fonts['info_text-decoration']}
	{$fonts['info_text-transform']}
	{$fonts['info_letter-spacing']}
	{$fonts['info_margin-top']}
	{$fonts['info_margin-bottom']}
}

em, i,
.post-date, .rss-date 
.post_date, .post_meta_item, .post_counters_item,
.comments_list_wrap .comment_date,
.comments_list_wrap .comment_time,
.comments_list_wrap .comment_counters,
.top_panel .slider_engine_revo .slide_subtitle,
.logo_slogan,
fieldset legend,
figure figcaption,
.wp-caption .wp-caption-text,
.wp-caption .wp-caption-dd,
.wp-caption-overlay .wp-caption .wp-caption-text,
.wp-caption-overlay .wp-caption .wp-caption-dd,
.format-audio .post_featured .post_audio_author,
.post_item_single .post_content .post_meta,
.author_bio .author_link,
.comments_list_wrap .comment_posted,
.comments_list_wrap .comment_reply {
	{$fonts['info_font-family']}
}
.xdsoft_datetimepicker,
.search_wrap .search_results .post_meta_item,
.search_wrap .search_results .post_counters_item {
	{$fonts['p_font-family']}
}

.logo_text {
	{$fonts['logo_font-family']}
	{$fonts['logo_font-size']}
	{$fonts['logo_font-weight']}
	{$fonts['logo_font-style']}
	{$fonts['logo_line-height']}
	{$fonts['logo_text-decoration']}
	{$fonts['logo_text-transform']}
	{$fonts['logo_letter-spacing']}
}
.logo_footer_text {
	{$fonts['logo_font-family']}
}

.menu_main_nav_area {
	{$fonts['menu_font-size']}
	{$fonts['menu_line-height']}
}
.menu_main_nav > li,
.menu_main_nav > li > a {
	{$fonts['menu_font-family']}
	{$fonts['menu_font-weight']}
	{$fonts['menu_font-style']}
	{$fonts['menu_text-decoration']}
	{$fonts['menu_text-transform']}
	{$fonts['menu_letter-spacing']}
}
.menu_main_nav > li ul,
.menu_main_nav > li ul > li,
.menu_main_nav > li ul > li > a {
	{$fonts['submenu_font-family']}
	{$fonts['submenu_font-size']}
	{$fonts['submenu_font-weight']}
	{$fonts['submenu_font-style']}
	{$fonts['submenu_line-height']}
	{$fonts['submenu_text-decoration']}
	{$fonts['submenu_text-transform']}
	{$fonts['submenu_letter-spacing']}
}
.menu_mobile .menu_mobile_nav_area > ul > li,
.menu_mobile .menu_mobile_nav_area > ul > li > a {
	{$fonts['menu_font-family']}
}
.menu_mobile .menu_mobile_nav_area > ul > li li,
.menu_mobile .menu_mobile_nav_area > ul > li li > a {
	{$fonts['submenu_font-family']}
}


/* Custom Headers */
.sc_layouts_row,
.sc_layouts_row input[type="text"] {
	{$fonts['menu_font-family']}
	{$fonts['menu_font-size']}
	{$fonts['menu_font-weight']}
	{$fonts['menu_font-style']}
	{$fonts['menu_line-height']}
}
.sc_layouts_row .sc_button_wrap .sc_button {
	{$fonts['button_font-family']}
	{$fonts['button_font-size']}
	{$fonts['button_font-weight']}
	{$fonts['button_font-style']}
	{$fonts['button_line-height']}
	{$fonts['button_text-decoration']}
	{$fonts['button_text-transform']}
	{$fonts['button_letter-spacing']}
}
.sc_layouts_menu_nav > li,
.sc_layouts_menu_nav > li > a {
	{$fonts['menu_font-family']}
	{$fonts['menu_font-weight']}
	{$fonts['menu_font-style']}
	{$fonts['menu_text-decoration']}
	{$fonts['menu_text-transform']}
	{$fonts['menu_letter-spacing']}
}
.sc_layouts_menu_nav > li ul,
.sc_layouts_menu_nav > li ul > li,
.sc_layouts_menu_nav > li ul > li > a {
	{$fonts['submenu_font-family']}
	{$fonts['submenu_font-size']}
	{$fonts['submenu_font-weight']}
	{$fonts['submenu_font-style']}
	{$fonts['submenu_line-height']}
	{$fonts['submenu_text-decoration']}
	{$fonts['submenu_text-transform']}
	{$fonts['submenu_letter-spacing']}
}


CSS;
			$rez = apply_filters('wisemove_filter_get_css', $rez, false, $fonts, '');
			$css['fonts'] = $rez['fonts'];
		}

		if ($colors !== false) {
			$schemes = empty($only_scheme) ? array_keys(wisemove_get_list_schemes()) : array($only_scheme);
	
			if (count($schemes) > 0) {
				$rez = array();
				foreach ($schemes as $scheme) {
					// Prepare colors
					if (empty($only_scheme)) $colors = wisemove_get_scheme_colors($scheme);
	
					// Make theme-specific colors and tints
					$colors = wisemove_customizer_add_theme_colors($colors);
			
					// Make styles
					$rez['colors'] = <<<CSS

/* Common tags */
h1, h2, h3, h4, h5, h6,
h1 a, h2 a, h3 a, h4 a, h5 a, h6 a,
li a {
	color: {$colors['text_dark']};
}
h1 a:hover, h2 a:hover, h3 a:hover, h4 a:hover, h5 a:hover, h6 a:hover{
	color: {$colors['text_link']};
}

dt, b, strong, i, em, mark, ins {	
	color: {$colors['text_dark']};
}
s, strike, del {	
	color: {$colors['text_light']};
}

code {
	color: {$colors['text']};
	background-color: transparent;
	border-color: {$colors['alter_bd_color']};
}
code a {
	color: {$colors['alter_link']};
}
code a:hover {
	color: {$colors['alter_hover']};
}

a {
	color: {$colors['text_link']};
}
a:hover {
	color: {$colors['text_hover']};
}

blockquote {
	color: {$colors['bg_color']};
	background-color: {$colors['text_dark']};
}
blockquote:before {
	color: {$colors['text_link']};
}
blockquote a {
	color: {$colors['bg_color']};
}
blockquote a:hover {
	color: {$colors['text_link']};
}

table th, table th + th, table td + th  {
	border-color: {$colors['bg_color_02']};
}
table td, table th + td, table td + td {
	color: {$colors['alter_dark']};
	border-color: {$colors['bd_color']};
}
table > tbody > tr:first-child > td{
    border-color: {$colors['inverse_dark']};
}
table th {
	color: {$colors['bg_color']};
	background-color: {$colors['text_dark']};
}
table > tbody > tr:nth-child(2n+1) > th, 
table > tbody > tr:nth-child(2n+1) > td {
	background-color: {$colors['alter_bg_color']};
}
table > tbody > tr:nth-child(2n) > th,
table > tbody > tr:nth-child(2n) > td {
	background-color: {$colors['alter_bg_hover']};
}
table th a{
	color: {$colors['text_hover']};
}
table th a:hover {
	color: {$colors['bg_color']};
}
table tbody td a:hover {
	color: {$colors['text_hover']};
}
table > tbody > tr:nth-child(2n) > td, table tbody th {
	background-color: {$colors['alter_bg_color_02']};
}
.wp-block-calendar table tbody tr:first-child td,
.widget_calendar table tbody tr:first-child td{
     color: {$colors['alter_light']};
}
.wp-block-calendar table thead + tbody tr:first-child td,
.widget_calendar table thead + tbody tr:first-child td{
     color: {$colors['alter_light']};
}
table > thead + tbody > tr:first-child > td{
    border-color: {$colors['bd_color']}!important;
}
table th a:hover {
	color: {$colors['bg_color']};
}
table tbody th a:hover {
	color: {$colors['text_dark']};
}
table {
     background-color: {$colors['alter_bg_hover']};
}

hr {
	border-color: {$colors['bd_color']};
}
figure figcaption,
.wp-caption .wp-caption-text,
.wp-caption .wp-caption-dd,
.wp-caption-overlay .wp-caption .wp-caption-text,
.wp-caption-overlay .wp-caption .wp-caption-dd {
	color: {$colors['inverse_light']};
	background-color: {$colors['alter_bg_hover']};
}
ul > li:before {
	color: {$colors['text_link']};
}

.footer_widgets_inner .wp-block-calendar td#prev a::before,
.footer_widgets_inner .wp-block-calendar td#next a::before,
.footer_widgets_inner .widget_calendar td#prev a::before,
.footer_widgets_inner .widget_calendar td#next a::before {
    background-color: {$colors['alter_bg_color']};
}

/* Form fields */
fieldset {
	border-color: {$colors['bd_color']};
}
fieldset legend {
	color: {$colors['text_dark']};
	background-color: {$colors['bg_color']};
}
input[type="text"],
input[type="date"],
input[type="number"],
input[type="email"],
input[type="tel"],
input[type="search"],
input[type="password"],
.widget_search form,
.select_container,
.select_container:before,
.select2-container .select2-choice,
textarea,
textarea.wp-editor-area {
	color: {$colors['input_light']};
	border-color: {$colors['alter_bg_hover']};
	background-color: {$colors['alter_bg_hover']};
}

.sidebar input[type="text"],
.sidebar input[type="number"],
.sidebar input[type="email"],
.sidebar input[type="tel"],
.sidebar input[type="search"],
.sidebar input[type="password"],
.sidebar .widget_search form .search-field,
.sidebar .select_container,
.sidebar .select_container:before,
.sidebar .select2-container .select2-choice,
.sidebar textarea,
.sidebar textarea.wp-editor-area {
	color: {$colors['input_light']};
	border-color: {$colors['input_bd_color']};
	background-color: {$colors['bg_color']};
}
form.wp-block-search button.wp-block-search__button:after{
    color: {$colors['input_light']};
}

.footer_widgets_inner .widget_search form, .footer_widgets_inner input[type="search"]{
    color: {$colors['text']};
}
.select_container select {
	color: {$colors['input_light']};
}
.footer_widgets_inner .select_container select{
    color: {$colors['text']};
}.footer_widgets_inner .select_container select:focus{
    color: {$colors['text']};
}
 .footer_widgets_inner .select_container:after, .footer_widgets_inner .select_container:hover:after{
 color: {$colors['text']};
 }

input[type="text"]:focus,
input[type="number"]:focus,
input[type="email"]:focus,
input[type="tel"]:focus,
input[type="search"]:focus,
input[type="password"]:focus,
.select_container:hover,
.select_container:before:hover,
select option:hover,
select option:focus,
.select2-container .select2-choice:hover,
textarea:focus,
textarea.wp-editor-area:focus {
	color: {$colors['input_dark']};
	border-color: {$colors['input_bd_hover']};
	background-color: {$colors['input_bg_hover']};
}

.footer_widgets_inner .widget_search form:hover:after{
    color: {$colors['text']};
}
.select_container select:focus {
	color: {$colors['input_dark']};
	border-color: {$colors['input_bd_hover']};
}
.select_container:after {
	color: {$colors['input_light']};
}
.select_container:hover:after {
	color: {$colors['input_dark']};
}
form.wp-block-search:hover button.wp-block-search__button:after,
.widget_search form:hover:after {
	color: {$colors['input_dark']};
}
input::-webkit-input-placeholder,
textarea::-webkit-input-placeholder {
	color: {$colors['input_light']};
}
.wpcf7-form .contact_us span[class*='acceptance'] input[type="checkbox"] + span:before,
input[type="radio"] + label:before,
input[type="checkbox"] + label:before,
.wpcf7-wpgdprc input[name="wpgdprc"] + span:before {
	border-color: {$colors['bd_color']};
	background-color: {$colors['input_bg_color']};
}
.wpcf7-form .contact_us span[class*='acceptance'] input[type="checkbox"]:checked + span:before,
input[type="checkbox"]:checked + label:before,
.wpcf7-wpgdprc input[name="wpgdprc"]:checked + span:before {
	color: {$colors['accent2']};
}
button,
input[type="reset"],
input[type="submit"],
input[type="button"] {
	background-color: {$colors['text_link']};
	color: {$colors['inverse_text']};
}
button[disabled],
button[disabled]:after,
input[type="submit"][disabled],
input[type="button"][disabled] {
    background-color: {$colors['text_light']} !important;
    color: {$colors['text']} !important;
}
input[type="submit"]:hover,
input[type="reset"]:hover,
input[type="button"]:hover,
button:hover,
input[type="submit"]:focus,
input[type="reset"]:focus,
input[type="button"]:focus,
button:focus {
	background-color: {$colors['text_dark']};
	color: {$colors['bg_color']};
}
.wp-editor-container input[type="button"] {
	background-color: {$colors['alter_bg_color']};
	border-color: {$colors['alter_bd_color']};
	color: {$colors['alter_dark']};
	-webkit-box-shadow: 0 1px 0 0 {$colors['alter_bd_hover']};
	   -moz-box-shadow: 0 1px 0 0 {$colors['alter_bd_hover']};
			box-shadow: 0 1px 0 0 {$colors['alter_bd_hover']};	
}
.wp-editor-container input[type="button"]:hover,
.wp-editor-container input[type="button"]:focus {
	background-color: {$colors['alter_bg_hover']};
	border-color: {$colors['alter_bd_hover']};
	color: {$colors['alter_link']};
}

.select2-results {
	color: {$colors['input_text']};
	border-color: {$colors['input_bd_hover']};
	background: {$colors['input_bg_color']};
}
.select2-results .select2-highlighted {
	color: {$colors['input_dark']};
	background: {$colors['input_bg_hover']};
}

.wp-block-search .wp-block-search__button {
	color:{$colors['inverse_text']};
	background-color: {$colors['text_link']};
}

.wp-block-search .wp-block-search__button:hover {
	color:{$colors['inverse_text']};
	background-color:{$colors['text_hover']};
}

.wp-block-search.wp-block-search__button-inside .wp-block-search__inside-wrapper .wp-block-search__button {
	background-color: transparent;
	color: {$colors['input_light']};
}
.wp-block-search.wp-block-search__button-inside .wp-block-search__inside-wrapper .wp-block-search__button:hover,
.wp-block-search.wp-block-search__button-inside:hover .wp-block-search__inside-wrapper .wp-block-search__button {
    color: {$colors['text']};
}
/**/
.scheme_self.footer_wrap .wp-block-search .wp-block-search__button {
	color:{$colors['text']};
	background-color: {$colors['text_link']};
}

.scheme_self.footer_wrap .wp-block-search .wp-block-search__button:hover {
	color:{$colors['inverse_text']};
	background-color:{$colors['text_hover']};
}

.scheme_self.footer_wrap .wp-block-search.wp-block-search__button-inside .wp-block-search__inside-wrapper .wp-block-search__button {
	background-color: transparent;
	color: {$colors['text']};
}
.scheme_self.footer_wrap .wp-block-search.wp-block-search__button-inside .wp-block-search__inside-wrapper .wp-block-search__button:hover,
.scheme_self.footer_wrap .wp-block-search.wp-block-search__button-inside:hover .wp-block-search__inside-wrapper .wp-block-search__button {
    color: {$colors['text_hover']};
}
/**/
.wp-block-button:not(.is-style-outline) > .wp-block-button__link {
	color:{$colors['inverse_text']};
} 
.wp-block-button:not(.is-style-outline) > .wp-block-button__link:hover {
	color: {$colors['text_hover']};
}
.is-style-outline>.wp-block-button__link:not(.has-text-color):hover, 
.wp-block-button__link.is-style-outline:not(.has-text-color):hover {
	border-color:{$colors['text_hover']};
}

/* WP Standard classes */
.sticky {
	border-color: {$colors['bd_color']};
}
.sticky .label_sticky {
	border-top-color: {$colors['text_link']};
}
	

/* Page */
body {
	color: {$colors['text']};
	background-color: {$colors['bg_color']};
}
#page_preloader,
.scheme_self.header_position_under .page_content_wrap,
.page_wrap {
	background-color: {$colors['bg_color']};
}
.preloader_wrap > div {
	background-color: {$colors['text_link']};
}

/* Header
------------------------------------------------ */
.scheme_self.top_panel.with_bg_image:before {
	background-color: {$colors['bg_color_07']};
}
.top_panel .slider_engine_revo .slide_subtitle {
	color: {$colors['text_link']};
}
.scheme_self.top_panel_title{
    background-color: {$colors['bd_color']};
}
.top_panel_custom_text .phone_header {
    color: {$colors['text_dark']};
}
.top_panel_custom_text .phone_header:hover {
    color: {$colors['accent2']};
}
.top_panel_custom_text .phone_header:before{
    color: {$colors['text_hover']};
}
.scheme_self.top_panel_title .sc_layouts_title_caption{
     color: {$colors['inverse_text']};
}

/* Custom Headers
----------------------------------------- */

.sc_layouts_row_delimiter,
.scheme_self.sc_layouts_row_delimiter {
	border-color: {$colors['bd_color']};
}

.sc_layouts_item_icon {
	color: {$colors['text_light']};
}
.sc_layouts_item_details_line1 {
	color: {$colors['text_link']};
}
.sc_layouts_item_details_line2 {
	color: {$colors['text_dark']};
}

.sc_layouts_row_fixed_on {
	background-color: {$colors['bg_color']};
}

/* Row type: Narrow */
.sc_layouts_row_type_narrow .sc_layouts_item,
.scheme_self.sc_layouts_row_type_narrow .sc_layouts_item {
	color: {$colors['text']};
}
.sc_layouts_row_type_narrow .sc_layouts_item a,
.scheme_self.sc_layouts_row_type_narrow .sc_layouts_item a {
	color: {$colors['text']};
}
.sc_layouts_row_type_narrow .sc_layouts_item a:hover,
.sc_layouts_row_type_narrow .sc_layouts_item a:hover .sc_layouts_item_icon,
.scheme_self.sc_layouts_row_type_narrow .sc_layouts_item a:hover,
.scheme_self.sc_layouts_row_type_narrow .sc_layouts_item a:hover .sc_layouts_item_icon {
	color: {$colors['text_dark']};
}
.sc_layouts_row_type_narrow .sc_layouts_item_icon,
.scheme_self.sc_layouts_row_type_narrow .sc_layouts_item_icon {
	color: {$colors['text_link']};
}
.sc_layouts_row_type_narrow .sc_layouts_item_details_line1,
.sc_layouts_row_type_narrow .sc_layouts_item_details_line2,
.scheme_self.sc_layouts_row_type_narrow .sc_layouts_item_details_line1,
.scheme_self.sc_layouts_row_type_narrow .sc_layouts_item_details_line2 {
	color: {$colors['text']};
}

.sc_layouts_row_type_narrow .socials_wrap .social_item a,
.scheme_self.sc_layouts_row_type_narrow .socials_wrap .social_item a {
	background-color: transparent;
	color: {$colors['text_link']};
}
.sc_layouts_row_type_narrow .socials_wrap .social_item a:hover,
.scheme_self.sc_layouts_row_type_narrow .socials_wrap .social_item a:hover {
	background-color: transparent;
	color: {$colors['text_hover']};
}

.sc_layouts_row_type_narrow .sc_button_wrap .sc_button,
.scheme_self.sc_layouts_row_type_narrow .sc_button_wrap .sc_button {
	background-color: transparent;
	border-color: {$colors['text_link']};
	color: {$colors['text_link']};
}
.sc_layouts_row_type_narrow .sc_button_wrap .sc_button:hover,
.scheme_self.sc_layouts_row_type_narrow .sc_button_wrap .sc_button:hover {
	background-color: transparent;
	border-color: {$colors['text_hover']};
	color: {$colors['text_hover']} !important;
}

.sc_layouts_row_type_narrow .search_wrap .search_submit,
.scheme_self.sc_layouts_row_type_narrow .search_wrap .search_submit {
	background-color: transparent;
	color: {$colors['text_link']};
}


/* Row type: Compact */
.sc_layouts_row_type_compact .sc_layouts_item,
.scheme_self.sc_layouts_row_type_compact .sc_layouts_item {
	color: {$colors['text']};
}
.sc_layouts_row_type_compact .sc_layouts_item a,
.scheme_self.sc_layouts_row_type_compact .sc_layouts_item a {
	color: {$colors['text']};
}
.sc_layouts_row_type_compact .sc_layouts_item a:hover,
.scheme_self.sc_layouts_row_type_compact .sc_layouts_item a:hover,
.sc_layouts_row_type_compact .sc_layouts_item a:hover .sc_layouts_item_icon,
.scheme_self.sc_layouts_row_type_compact .sc_layouts_item a:hover .sc_layouts_item_icon {
	color: {$colors['text_dark']};
}
.sc_layouts_row_type_compact .sc_layouts_item_icon,
.scheme_self.sc_layouts_row_type_compact .sc_layouts_item_icon {
	color: {$colors['text_link']};
}
.sc_layouts_row_type_compact .sc_layouts_item_details_line1,
.sc_layouts_row_type_compact .sc_layouts_item_details_line2,
.scheme_self.sc_layouts_row_type_compact .sc_layouts_item_details_line1,
.scheme_self.sc_layouts_row_type_compact .sc_layouts_item_details_line2 {
	color: {$colors['text']};
}

.sc_layouts_row_type_compact .socials_wrap .social_item a,
.scheme_self.sc_layouts_row_type_compact .socials_wrap .social_item a {
	background-color: transparent;
	color: {$colors['text_dark']};
}
.sc_layouts_row_type_compact .socials_wrap .social_item a:hover,
.scheme_self.sc_layouts_row_type_compact .socials_wrap .social_item a:hover {
	background-color: transparent;
	color: {$colors['text_hover']};
}

.sc_layouts_row_type_compact .search_wrap .search_submit,
.scheme_self.sc_layouts_row_type_compact .search_wrap .search_submit {
	background-color: transparent;
	color: {$colors['text_dark']};
}
.sc_layouts_row_type_compact .search_wrap .search_submit:hover,
.scheme_self.sc_layouts_row_type_compact .search_wrap .search_submit:hover {
	background-color: transparent;
	color: {$colors['text_hover']};
}
.sc_layouts_row_type_compact .search_wrap.search_style_normal .search_submit,
.scheme_self.sc_layouts_row_type_compact .search_wrap.search_style_normal .search_submit {
	color: {$colors['text_link']};
}
.sc_layouts_row_type_compact .search_wrap.search_style_normal .search_submit:hover,
.scheme_self.sc_layouts_row_type_compact .search_wrap.search_style_normal .search_submit:hover {
	color: {$colors['text_hover']};
}


/* Row type: Normal */
.sc_layouts_row_type_normal .sc_layouts_item,
.scheme_self.sc_layouts_row_type_normal .sc_layouts_item {
	color: {$colors['text']};
}
.sc_layouts_row_type_normal .sc_layouts_menu_nav:hover a:hover,
.scheme_self.sc_layouts_row_type_normal .sc_layouts_menu_nav:hover a:hover{
    color: {$colors['text_hover']};
}
.sc_layouts_row_type_normal .search_wrap .search_submit,
.scheme_self.sc_layouts_row_type_normal .search_wrap .search_submit {
	background-color: transparent;
	color: {$colors['input_light']};
}
.sc_layouts_row_type_normal .search_wrap .search_submit:hover,
.scheme_self.sc_layouts_row_type_normal .search_wrap .search_submit:hover {
	background-color: transparent;
	color: {$colors['input_text']};
}


/**/
.panel_right:before{
    background-color: {$colors['bd_color']};
}


/* Menu */
.sc_layouts_menu_nav > li > a {
	color: {$colors['text_dark']};
}
.sc_layouts_menu_nav > li > a:hover{
    color: {$colors['text_dark']};
}

.sc_layouts_menu_nav > li.current-menu-item > a,
.sc_layouts_menu_nav > li.current-menu-parent > a,
.sc_layouts_menu_nav > li.current-menu-ancestor > a {
	color: {$colors['text_hover']} !important;
}

.sc_layouts_menu_nav:hover > li.current-menu-item > a,
.sc_layouts_menu_nav:hover > li.current-menu-parent > a,
.sc_layouts_menu_nav:hover > li.current-menu-ancestor > a{
 color: {$colors['text_hover']}!important;
}

.sc_layouts_menu_nav:hover > li.current-menu-item > a:hover,
.sc_layouts_menu_nav:hover > li.current-menu-parent > a:hover,
.sc_layouts_menu_nav:hover > li.current-menu-ancestor > a:hover{
 color: {$colors['text_hover']}!important;
}

/* Submenu */
.sc_layouts_menu_nav > li ul {
	background-color: {$colors['accent2']};
}
.sc_layouts_menu_nav > li li > a {
	color: {$colors['inverse_text']};
}
.sc_layouts_menu_nav > li li > a:hover,
.sc_layouts_menu_nav > li li.sfHover > a {
	color: {$colors['text_dark']} !important;
}
.sc_layouts_menu_nav > li li.current-menu-item > a,
.sc_layouts_menu_nav > li li.current-menu-parent > a,
.sc_layouts_menu_nav > li li.current-menu-ancestor > a {
	color: {$colors['text_dark']};
}
.sc_layouts_menu_nav > li li[class*="icon-"]:before {
	color: {$colors['inverse_text']};
}
.sc_layouts_menu_nav > li li[class*="icon-"]:hover:before,
.sc_layouts_menu_nav > li li[class*="icon-"].shHover:before,
.sc_layouts_menu_nav > li li.current-menu-item:before,
.sc_layouts_menu_nav > li li.current-menu-parent:before,
.sc_layouts_menu_nav > li li.current-menu-ancestor:before {
	color: {$colors['text_hover']};
}

/* Logo */
.sc_layouts_logo b {
	color: {$colors['text_dark']};
}
.sc_layouts_logo i {
	color: {$colors['text_link']};
}
.sc_layouts_logo_text {
	color: {$colors['text_link']};
}
.sc_layouts_logo:hover .logo_text {
	color: {$colors['text_dark']};
}
.logo_slogan {
	color: {$colors['text']};
}

/* Social items */
.socials_wrap .social_item a,
.socials_wrap .social_item a i {
	color: {$colors['text_light']};
}
.socials_wrap .social_item a:hover,
.socials_wrap .social_item a:hover i {
	color: {$colors['text_dark']};
}


/* Search style 'Expand' */
.search_style_expand.search_opened {
	background-color: {$colors['bg_color']};
	border-color: {$colors['bd_color']};
}
.search_style_expand.search_opened .search_submit {
	color: {$colors['text']};
}
.search_style_expand .search_submit:hover,
.search_style_expand .search_submit:focus {
	color: {$colors['text_dark']};
}


/* Search style 'Fullscreen' */
.search_style_fullscreen.search_opened .search_form_wrap {
	background-color: {$colors['bg_color_09']};
}
.search_style_fullscreen.search_opened .search_form {
	border-color: {$colors['text_dark']};
}
.search_style_fullscreen.search_opened .search_close,
.search_style_fullscreen.search_opened .search_field,
.search_style_fullscreen.search_opened .search_submit {
	color: {$colors['input_dark']};
}
.search_style_fullscreen.search_opened .search_close:hover,
.search_style_fullscreen.search_opened .search_field:hover,
.search_style_fullscreen.search_opened .search_field:focus,
.search_style_fullscreen.search_opened .search_submit:hover,
.search_style_fullscreen.search_opened .search_submit:focus {
	color: {$colors['input_text']};
}
.search_style_fullscreen.search_opened input::-webkit-input-placeholder {color:{$colors['input_light']}; opacity: 1;}
.search_style_fullscreen.search_opened input::-moz-placeholder          {color:{$colors['input_light']}; opacity: 1;}/* Firefox 19+ */
.search_style_fullscreen.search_opened input:-moz-placeholder           {color:{$colors['input_light']}; opacity: 1;}/* Firefox 18- */
.search_style_fullscreen.search_opened input:-ms-input-placeholder      {color:{$colors['input_light']}; opacity: 1;}

.footer_widgets_inner .search-form input::-webkit-input-placeholder {color:{$colors['text']}; opacity: 1;}
.footer_widgets_inner .search-form input::-moz-placeholder          {color:{$colors['text']}; opacity: 1;}/* Firefox 19+ */
.footer_widgets_inner .search-form input:-moz-placeholder           {color:{$colors['text']}; opacity: 1;}/* Firefox 18- */
.footer_widgets_inner .search-form input:-ms-input-placeholder      {color:{$colors['text']}; opacity: 1;}


/* Search results */
.search_wrap .search_results {
	background-color: {$colors['bg_color']};
	border-color: {$colors['bd_color']};
}
.search_wrap .search_results:after {
	background-color: {$colors['bg_color']};
	border-left-color: {$colors['bd_color']};
	border-top-color: {$colors['bd_color']};
}
.search_wrap .search_results .search_results_close {
	color: {$colors['text_light']};
}
.search_wrap .search_results .search_results_close:hover {
	color: {$colors['text_dark']};
}
.search_results.widget_area .post_item + .post_item {
	border-top-color: {$colors['bd_color']};
}
.post_item_none_search .search_wrap .search_submit, .post_item_none_archive .search_wrap .search_submit{
    color: {$colors['text_dark']};
}
.post_item_none_search .search_wrap .search_submit:hover, .post_item_none_archive .search_wrap .search_submit:hover{
    color: {$colors['text_hover']};
}

/*  Menu  */
.menu_main_nav_area:after{
    background-color: {$colors['bd_color']};
}


/* Mobile menu */
.scheme_self.menu_side_wrap .menu_side_button {
	color: {$colors['alter_dark']};
	border-color: {$colors['alter_bd_color']};
	background-color: {$colors['alter_bg_color_07']};
}
.scheme_self.menu_side_wrap .menu_side_button:hover {
	color: {$colors['inverse_text']};
	border-color: {$colors['alter_hover']};
	background-color: {$colors['alter_link']};
}
.menu_side_inner,
.menu_mobile_inner {
	color: {$colors['alter_text']};
	background-color: {$colors['alter_bg_color']};
}
.menu_mobile_inner {
	color: {$colors['alter_text']};
	background-color: {$colors['alter_dark']};
}
.menu_mobile_button {
	color: {$colors['text_dark']};
}
.menu_mobile_button:hover {
	color: {$colors['text_link']};
}
.menu_mobile_close:before,
.menu_mobile_close:after {
	border-color: {$colors['inverse_hover']};
}
.menu_mobile_close:hover:before,
.menu_mobile_close:hover:after {
	border-color: {$colors['text_hover']};
}
.menu_mobile_inner a {
	color: {$colors['inverse_text']};
}
.menu_mobile_inner a:hover,
.menu_mobile_inner .current-menu-ancestor > a,
.menu_mobile_inner .current-menu-item > a {
	color: {$colors['text_hover']};
}
.menu_mobile_inner .menu_mobile_nav_area a:hover > .open_child_menu,
.menu_mobile_inner .current-menu-ancestor > a > .open_child_menu,
.menu_mobile_inner .current-menu-item > a > .open_child_menu{
    background-color: {$colors['inverse_hover']};
}
.menu_mobile_inner .search_mobile .search_submit {
	color: {$colors['input_light']};
}
.menu_mobile_inner .search_mobile .search_submit:focus,
.menu_mobile_inner .search_mobile .search_submit:hover {
	color: {$colors['input_dark']};
}
.menu_mobile_inner .search_mobile input[type="text"] {
	background-color: {$colors['inverse_hover']};
}

.menu_mobile_inner .social_item a {
	color: {$colors['text_hover']};
}
.menu_mobile_inner .social_item a:hover {
	color: {$colors['accent2']};
}
.menu_mobile .menu_mobile_nav_area .open_child_menu{
	background-color: {$colors['inverse_hover']};
}

/* Page title and breadcrumbs */
.sc_layouts_title .sc_layouts_title_meta {
	color: {$colors['text']};
}
.sc_layouts_title .sc_layouts_title_description {
	color: {$colors['text_light']};
}
.sc_layouts_title_breadcrumbs {
	color: {$colors['alter_light']};
}
.sc_layouts_title_breadcrumbs a {
	color: {$colors['text_dark']};
}
.sc_layouts_title_breadcrumbs a:hover {
	color: {$colors['text_hover']};
}


/* Tabs */
.wisemove_tabs .wisemove_tabs_titles li a {
	color: {$colors['alter_dark']};
	background-color: {$colors['alter_bg_color']};
}
.wisemove_tabs .wisemove_tabs_titles li a:hover {
	color: {$colors['inverse_text']};
	background-color: {$colors['text_link']};
}
.wisemove_tabs .wisemove_tabs_titles li.ui-state-active a {
	color: {$colors['bg_color']};
	background-color: {$colors['text_dark']};
}

/* Post layouts */
.post_item {
	color: {$colors['text']};
}
.post_meta,
.post_meta_item,
.post_meta_item a,
.post_meta_item:before,
.post_meta_item:hover:before,
.post_date a,
.post_date:before,
.post_info .post_info_item,
.post_info .post_info_item a,
.post_info_counters .post_counters_item,
.post_counters .socials_share .socials_caption:before,
.post_counters .socials_share .socials_caption:hover:before {
	color: {$colors['text_light']};
}
.post_date a:hover,
a.post_meta_item:hover,
.post_meta_item a:hover,
.post_info .post_info_item a:hover,
.post_info_counters .post_counters_item:hover {
	color: {$colors['text_dark']};
}

.post_item .post_title a:hover,
.post_item .post_title a:hover em,
.post_item .post_title a:hover b  {
	color: {$colors['text_hover']};
}

.post_meta_item.post_categories,
.post_meta_item.post_categories a {
	color: {$colors['text_link']};
}
.post_meta_item.post_categories a:hover {
	color: {$colors['text_hover']};
}
.post_meta_item.post_date,
.post_meta_item.post_date a {
	color: {$colors['text']};
}
.post_meta_item.post_date a:hover {
	color: {$colors['text_hover']};
}

.post_meta_item .socials_share .social_items {
	background-color: {$colors['bg_color']};
}
.post_meta_item .social_items,
.post_meta_item .social_items:before {
	background-color: {$colors['bg_color']};
	border-color: {$colors['bd_color']};
	color: {$colors['text_light']};
}

.post_layout_excerpt + .post_layout_excerpt {
	border-color: {$colors['bd_color']};
}
.post_layout_classic {
	border-color: {$colors['bd_color']};
}

.scheme_self.gallery_preview:before {
	background-color: {$colors['bg_color']};
}
.scheme_self.gallery_preview {
	color: {$colors['text']};
}

/* Post Formats */
.format-audio .post_featured .post_audio_author {
	color: {$colors['text_link']};
}
.format-audio .post_featured.without_thumb .post_audio {
	border-color: {$colors['bd_color']};
}
.format-audio .post_featured.without_thumb .post_audio_title,
.without_thumb .mejs-controls .mejs-currenttime,
.without_thumb .mejs-controls .mejs-duration {
	color: {$colors['text_dark']};
}

.mejs-controls .mejs-button,
.mejs-controls .mejs-time-rail .mejs-time-current,
.mejs-controls .mejs-horizontal-volume-slider .mejs-horizontal-volume-current {
	color: {$colors['inverse_text']};
	background: {$colors['accent2']};
}
.mejs-controls .mejs-button:hover {
	color: {$colors['bg_color']};
	background: {$colors['text_dark']};
}
.mejs-controls .mejs-time-rail .mejs-time-total,
.mejs-controls .mejs-time-rail .mejs-time-loaded,
.mejs-container .mejs-controls .mejs-horizontal-volume-slider .mejs-horizontal-volume-total {
	background: {$colors['text_link_02']};
}

.mejs-container .mejs-controls 	{
	border-color: {$colors['alter_bg_hover']};
	background-color: {$colors['alter_bg_hover']};
}

.mejs-container .mejs-controls .mejs-time {
	color: {$colors['text_dark']};
}

.format-aside .post_content_inner {
	color: {$colors['alter_dark']};
	background-color: {$colors['alter_bg_color']};
}

.format-link .post_content_inner,
.format-status .post_content_inner {
	color: {$colors['text_dark']};
}

.format-chat p > b,
.format-chat p > strong {
	color: {$colors['text_dark']};
}

.post_layout_chess .post_content_inner:after {
	background: linear-gradient(to top, {$colors['bg_color']} 0%, {$colors['bg_color_0']} 100%) no-repeat scroll right top / 100% 100% {$colors['bg_color_0']};
}
.post_layout_chess_1 .post_meta:before {
	background-color: {$colors['bd_color']};
}

/* Pagination */
.nav-links-old {
	color: {$colors['text_dark']};
}
.nav-links-old a:hover {
	color: {$colors['text_dark']};
	border-color: {$colors['text_dark']};
}

.page_links > a,
.comments_pagination .page-numbers,
.nav-links .page-numbers {
	color: {$colors['text_dark']};
}
.comments_pagination,
.nav-links,
.page_links{
    border-color: {$colors['bd_color']};
}
.page_links > a:hover,
.page_links > span:not(.page_links_title),
.comments_pagination a.page-numbers:hover,
.comments_pagination .page-numbers.current,
.nav-links a.page-numbers:hover,
.nav-links .page-numbers.current {
	color: {$colors['inverse_text']};
	background-color: {$colors['text_light']};
}

/* Single post */
.post_item_single .post_header .post_date {
	color: {$colors['text_light']};
}
.post_item_single .post_header .post_categories,
.post_item_single .post_header .post_categories a {
	color: {$colors['text_link']};
}
.post_item_single .post_header .post_meta_item,
.post_item_single .post_header .post_meta_item:before,
.post_item_single .post_header .post_meta_item:hover:before,
.post_item_single .post_header .post_meta_item a,
.post_item_single .post_header .post_meta_item a:before,
.post_item_single .post_header .post_meta_item a:hover:before,
.post_item_single .post_header .post_meta_item .socials_caption,
.post_item_single .post_header .post_meta_item .socials_caption:before,
.post_item_single .post_header .post_edit a {
	color: {$colors['text_light']};
}
.post_item_single .post_meta_item > a:hover,
.post_item_single .post_meta_item .socials_caption:hover,
.post_item_single .post_edit a:hover {
	color: {$colors['text_hover']};
}
.post_item_single .post_content .post_meta_label,
.post_item_single .post_content .post_meta_item:hover .post_meta_label {
	color: {$colors['text_dark']};
}
.post_item_single .post_content .post_tags,
.post_item_single .post_content .post_tags a {
	color: {$colors['text_link']};
}
.post_item_single .post_content .post_tags a:hover {
	color: {$colors['text_hover']};
}
.post_item_single .post_content .post_meta .post_share .social_item a {
	color: {$colors['inverse_text']} !important;
	background-color: {$colors['accent2']}!important;
}
.post_item_single .post_content .post_meta .post_share .social_item a:hover {
	background-color: {$colors['text_hover']}!important;
}
.post_item_single .post_content > .post_meta_single .post_tags a {
    color: {$colors['alter_light']};
	background-color: {$colors['alter_bd_hover']};
}
.post_item_single .post_content > .post_meta_single .post_tags a:hover{
color: {$colors['inverse_text']} !important;
	background-color: {$colors['text_hover']};
}

.post-password-form input[type="submit"] {
	border-color: {$colors['text_dark']};
}
.post-password-form input[type="submit"]:hover,
.post-password-form input[type="submit"]:focus {
	color: {$colors['bg_color']};
}

/* Single post navi */
.nav-links-single .nav-links {
	border-color: {$colors['bd_color']};
}
.nav-links-single .nav-links a .meta-nav {
	color: {$colors['text_light']};
}
.nav-links-single .nav-links a .post_date {
	color: {$colors['text_light']};
}
.nav-links-single .nav-links a:hover .meta-nav,
.nav-links-single .nav-links a:hover .post_date {
	color: {$colors['text_dark']};
}
.nav-links-single .nav-links a:hover .post-title {
	color: {$colors['text_link']};
}

/* Author info */
.scheme_self.author_info {
	color: {$colors['text']};
	background-color: {$colors['alter_bg_hover']};
}
.scheme_self.author_info .author_title {
	color: {$colors['alter_dark']};
}
.scheme_self.author_info a {
	color: {$colors['accent2']};
}
.scheme_self.author_info a:hover {
	color: {$colors['text_hover']};
}
.author_info:before{
    background-color: {$colors['bd_color']};
}


/* Related posts */
.related_wrap {
	border-color: {$colors['bd_color']};
}
.related_wrap .related_item_style_1 .post_header {
	background-color: {$colors['bg_color_07']};
}
.related_wrap .related_item_style_1:hover .post_header {
	background-color: {$colors['bg_color']};
}
.related_wrap .related_item_style_1 .post_date a {
	color: {$colors['text']};
}
.related_wrap .related_item_style_1:hover .post_date a {
	color: {$colors['text_light']};
}
.related_wrap .related_item_style_1:hover .post_date a:hover {
	color: {$colors['text_dark']};
}

/* Comments */
.comments_list_wrap,
.comments_list_wrap > ul {
	border-color: {$colors['bd_color']};
}
.comments_list_wrap li + li,
.comments_list_wrap li ul {
	border-color: {$colors['bd_color']};
}
.comments_list_wrap .comment_info {
	color: {$colors['text_dark']};
}
.comments_list_wrap .comment_counters a {
	color: {$colors['text_link']};
}
.comments_list_wrap .comment_counters a:before {
	color: {$colors['text_link']};
}
.comments_list_wrap .comment_counters a:hover:before,
.comments_list_wrap .comment_counters a:hover {
	color: {$colors['text_hover']};
}
.comments_list_wrap .comment_text {
	color: {$colors['text']};
}
.comments_list_wrap .comment_date{
    color: {$colors['text']};
}
.comments_list_wrap .comment_reply a{
     color: {$colors['accent2']};
}
.comments_list_wrap .comment_reply a:hover{
     color: {$colors['text_hover']};
}
.comments_form_wrap {
	border-color: {$colors['bd_color']};
}
.comments_wrap .comments_notes {
	color: {$colors['text_light']};
}
.comments_wrap .form-submit input[type="submit"]{
    background-color: {$colors['accent2']}!important;
}
.comments_wrap .form-submit input[type="submit"]:hover{
    background-color: {$colors['text_hover']}!important;
}



.comments_field.comments_comment textarea::-webkit-input-placeholder {color:{$colors['text']}; opacity: 1;}
.comments_field.comments_comment textarea::-moz-placeholder          {color:{$colors['text']}; opacity: 1;}/* Firefox 19+ */
.comments_field.comments_comment textarea:-moz-placeholder           {color:{$colors['text']}; opacity: 1;}/* Firefox 18- */
.comments_field.comments_comment textarea:-ms-input-placeholder      {color:{$colors['text']}; opacity: 1;}

.comments_field.comments_comment input::-webkit-input-placeholder {color:{$colors['text']}; opacity: 1;}
.comments_field.comments_comment input::-moz-placeholder          {color:{$colors['text']}; opacity: 1;}
.comments_field.comments_comment input:-moz-placeholder           {color:{$colors['text']}; opacity: 1;}/* Firefox 18- */
.comments_field.comments_comment input:-ms-input-placeholder      {color:{$colors['text']}; opacity: 1;}




/* Page 404 */
.post_item_404 .page_title {
	color: {$colors['text_light']};
}
.post_item_404 .page_description {
	color: {$colors['text_link']};
}


/* Sidebar */
.sidebar_inner {
	background-color: {$colors['alter_bg_hover']};
	color: {$colors['alter_text']};
}
.sidebar_inner .widget + .widget {
	border-color: {$colors['alter_bd_color']};
}
.sidebar_inner h1, .sidebar_inner h2, .sidebar_inner h3, .sidebar_inner h4, .sidebar_inner h5, .sidebar_inner h6,
.sidebar_inner h1 a, .sidebar_inner h2 a, .sidebar_inner h3 a, .sidebar_inner h4 a, .sidebar_inner h5 a, .sidebar_inner h6 a {
	color: {$colors['alter_dark']};
}
.sidebar_inner h1 a:hover, .sidebar_inner h2 a:hover, .sidebar_inner h3 a:hover, .sidebar_inner h4 a:hover, .sidebar_inner h5 a:hover, .sidebar_inner h6 a:hover {
	color: {$colors['alter_link']};
}

/* Vc */

h4.vc_custom_heading strong{
    color: {$colors['accent2']};
}



/* Widgets */
.widget {
	color: {$colors['text']};
}
ul.wp-block-rss li:before,
ul.wp-block-page-list li:before,
ul.wp-block-archives-list li:before,
ul.wp-block-categories-list li:before,
ul.wp-block-categories__list li:before,
.widget li:before {
	background-color: {$colors['text_hover']};
}
.widget.widget_recent_comments li{
    color: {$colors['text_light']};
}
.footer_widgets_inner .widget.widget_recent_comments li{
    color: {$colors['text_link']};
}
.footer_widgets_inner .widget.widget_recent_comments li a{
 color: {$colors['text']};
}
.footer_widgets_inner .widget.widget_recent_comments li a:hover{
 color: {$colors['text_hover']};
}
.widget a {
	color: {$colors['text_link']};
}
.widget a:hover {
	color: {$colors['text_hover']};
}
.widget li > a,
.widget .post_title > a {
	color: {$colors['alter_dark']};
}
.widget li > a:hover,
.widget .post_title > a:hover {
	color: {$colors['alter_link']};
}
.widget .comment-author-link{
    color: {$colors['text_link']};
}

.footer_widgets_wrap .widget li > a,
.footer_widgets_wrap .widget .post_title > a {
	color: {$colors['inverse_text']};
}
.footer_widgets_wrap .widget li > a:hover,
.footer_widgets_wrap .widget .post_title > a:hover {
	color: {$colors['accent2']};
}
.footer_widgets_wrap .post_counters_item:before{
    color: {$colors['accent2']};
}
.footer_widgets_wrap .post_counters_item .post_counters_number{
    	color: {$colors['inverse_text']};
}
.footer_widgets_wrap.widget_area .post_item .post_info .post_info_item a{
    color: {$colors['inverse_text']};
}


/* Archive */
.widget_archive li {
	color: {$colors['alter_dark']};
}

.footer_widgets_inner .widget_archive li {
	color: {$colors['text']};
}
/* Calendar */
.wp-block-calendar caption,
.wp-block-calendar tbody td a,
.wp-block-calendar th,
.widget_calendar caption,
.widget_calendar tbody td a,
.widget_calendar th {
	color: {$colors['text_dark']};
}
.wp-block-calendar td a:hover,
.widget_calendar tbody td a:hover {
	color: {$colors['alter_link']};
}
.wp-block-calendar tbody td a:after,
.widget_calendar tbody td a:after {
	background-color: {$colors['text_hover']};
}
.wp-block-calendar td#today,
.widget_calendar td#today {
	color: {$colors['inverse_text']} !important;
}
.wp-block-calendar td#today a,
.widget_calendar td#today a {
	color: {$colors['inverse_link']};
}
.wp-block-calendar td#today a:hover,
.widget_calendar td#today a:hover {
	color: {$colors['inverse_hover']};
}
.wp-block-calendar td#today:before,
.widget_calendar td#today:before {
	background-color: {$colors['text_hover']};
}
.wp-block-calendar td#today a:after,
.widget_calendar td#today a:after {
	background-color: {$colors['inverse_link']};
}
.wp-block-calendar td#today a:hover:after,
.widget_calendar td#today a:hover:after {
	background-color: {$colors['inverse_hover']};
}
.widget_calendar td#prev a,
.widget_calendar td#next a,
.widget_calendar .wp-calendar-nav a,
.wp-block-calendar td#prev a,
.wp-block-calendar td#next a,
.wp-block-calendar .wp-calendar-nav a {
	color: {$colors['text_hover']};
}
.widget_calendar td#prev a:hover,
.widget_calendar td#next a:hover,
.widget_calendar .wp-calendar-nav a:hover,
.wp-block-calendar td#prev a:hover,
.wp-block-calendar td#next a:hover,
.wp-block-calendar .wp-calendar-nav a:hover {
	color: {$colors['text_link']};
}

.widget_calendar td#prev a:before,
.widget_calendar td#next a:before,
.widget_calendar .wp-calendar-nav a:before,
.wp-block-calendar td#prev a:before,
.wp-block-calendar td#next a:before,
.wp-block-calendar .wp-calendar-nav a:before {
	background-color: {$colors['bg_color']};
}
.sidebar .widget_calendar td#prev a:before,
.sidebar .widget_calendar td#next a:before,
.sidebar .wp-calendar-nav a:before,
.sidebar .wp-block-calendar td#prev a:before,
.sidebar .wp-block-calendar td#next a:before,
.sidebar .wp-block-calendar .wp-calendar-nav a:before {
	background-color: {$colors['alter_bg_hover']};
}
.wp-block-calendar th, 
.wp-block-calendar td,
.widget_calendar th, 
.widget_calendar td{
    color: {$colors['alter_light']};
}

/* Categories */
.widget_categories li {
	color: {$colors['alter_dark']};
}
.footer_widgets_inner .widget_categories li {
	color: {$colors['text']};
}

/* Tag cloud */
.scheme_self.footer_wrap .wp-block-tag-cloud a,
.scheme_self.footer_wrap .widget_product_tag_cloud a,
.scheme_self.footer_wrap .widget_tag_cloud a,
.wp-block-tag-cloud a,
.widget_product_tag_cloud a,
.widget_tag_cloud a {
	color: {$colors['alter_light']};
	background-color: {$colors['alter_bd_hover']};
}
.wp-block-tag-cloud a:hover,
.widget_product_tag_cloud a:hover,
.widget_tag_cloud a:hover {
	color: {$colors['inverse_text']} !important;
	background-color: {$colors['text_hover']};
}

.footer_widgets_inner .widget_product_tag_cloud a,
.footer_widgets_inner .widget_tag_cloud a {

	background-color: {$colors['inverse_text']};
}
.footer_widgets_inner .widget_product_tag_cloud a:hover,
.footer_widgets_inner .widget_tag_cloud a:hover {

	background-color: {$colors['text_hover']};
}

/* RSS */
.widget_rss .widget_title a:first-child {
	color: {$colors['alter_link']};
}
.widget_rss .widget_title a:first-child:hover {
	color: {$colors['alter_hover']};
}
.widget_rss .rss-date {
	color: {$colors['alter_light']};
}

/* Text */
.widget_text .mail_footer:before, .widget_text .phone_footer:before, .widget_text .address_footer:before{
    color: {$colors['accent2']};
}

/* Footer */
.scheme_self.footer_wrap {
	background-color: {$colors['alter_bg_color']};
	color: {$colors['alter_text']};
}
.scheme_self.footer_wrap .widget,
.scheme_self.footer_wrap .sc_content .wpb_column {
	border-color: {$colors['alter_bd_color']};
}
.scheme_self.footer_wrap h1, .scheme_self.footer_wrap h2, .scheme_self.footer_wrap h3, .scheme_self.footer_wrap h4, .scheme_self.footer_wrap h5, .scheme_self.footer_wrap h6,
.scheme_self.footer_wrap h1 a, .scheme_self.footer_wrap h2 a, .scheme_self.footer_wrap h3 a, .scheme_self.footer_wrap h4 a, .scheme_self.footer_wrap h5 a, .scheme_self.footer_wrap h6 a {
	color: {$colors['text_dark']};
}
.scheme_self.footer_wrap h1 a:hover, .scheme_self.footer_wrap h2 a:hover, .scheme_self.footer_wrap h3 a:hover, .scheme_self.footer_wrap h4 a:hover, .scheme_self.footer_wrap h5 a:hover, .scheme_self.footer_wrap h6 a:hover {
	color: {$colors['alter_link']};
}
.scheme_self.footer_wrap a {
	color: {$colors['alter_dark']};
}
.scheme_self.footer_wrap a:hover {
	color: {$colors['alter_link']};
}
.scheme_self.footer_wrap .widget_text a {
	color: {$colors['text_link']};
}
.scheme_self.footer_wrap .widget_text a:hover{
	color: {$colors['text_hover']};
}
.scheme_self.footer_wrap .widget_calendar td#prev a:before,
.scheme_self.footer_wrap .widget_calendar td#next a:before,
.scheme_self.footer_wrap .wp-calendar-nav a:before,
.scheme_self.footer_wrap .wp-block-calendar td#prev a:before,
.scheme_self.footer_wrap .wp-block-calendar td#next a:before,
.scheme_self.footer_wrap .wp-block-calendar .wp-calendar-nav a:before {
	background-color: {$colors['alter_bg_color']};
}
.footer_logo_inner {
	border-color: {$colors['alter_bd_color']};
}
.footer_logo_inner:after {
	background-color: {$colors['alter_text']};
}
.footer_socials_inner .social_item .social_icons {
	border-color: {$colors['alter_text']};
	color: {$colors['alter_text']};
}
.footer_socials_inner .social_item .social_icons:hover {
	border-color: {$colors['alter_dark']};
	color: {$colors['alter_dark']};
}
.menu_footer_nav_area ul li a {
	color: {$colors['inverse_text']};
}
.menu_footer_nav_area ul li a:hover {
	color: {$colors['alter_link']};
}
.menu_footer_nav_area ul li+li:before {
	border-color: {$colors['alter_light']};
}

.footer_copyright_inner {
	background-color: {$colors['alter_dark']};
	color: {$colors['alter_text']};
}
.footer_copyright_inner a {
	color: {$colors['text_dark']};
}
.footer_copyright_inner a:hover {
	color: {$colors['accent2']};
}
.footer_copyright_inner .copyright_text {
	color: {$colors['text']};
}
.footer_widgets_wrap .widget{
    color: {$colors['alter_bg_hover']};
}

/* Buttons */

.socials_share:not(.socials_type_drop) .social_icons {
	color: {$colors['inverse_text']} !important;
	background-color: {$colors['text_link']} !important;
}

.socials_share:not(.socials_type_drop) .social_icons:hover{
	color: {$colors['bg_color']} !important;
	background-color: {$colors['text_dark']} !important;
}
.theme_button,
.more-link{
    background-color: {$colors['accent2']};
    color: {$colors['inverse_text']} !important;
}
.theme_button:hover,
.more-link:hover{
    color: {$colors['inverse_text']} !important;
}

.format-video .post_featured.with_thumb .post_video_hover {
	color: {$colors['text_link']};
}
.format-video .post_featured.with_thumb .post_video_hover:hover {
	color: {$colors['inverse_text']};
	background-color: {$colors['text_link']};
}

.theme_scroll_down:hover {
	color: {$colors['text_link']};
}
.sc_item_button a.dark_button.sc_button{
    color: {$colors['text']};
    background-color: {$colors['inverse_text']};
}

/**/
.ui-datepicker th{
  color: {$colors['text']};
}
.ui-datepicker-calendar .ui-state-default, .ui-datepicker-calendar .ui-widget-content .ui-state-default, .ui-datepicker-calendar .ui-widget-header .ui-state-default{
color: {$colors['text']};
}
.ui-datepicker-calendar .ui-state-default:hover, .ui-datepicker-calendar .ui-widget-content .ui-state-default:hover, .ui-datepicker-calendar .ui-widget-header .ui-state-default:hover{
color: {$colors['inverse_text']}!important;
    background-color: {$colors['text_hover']}!important;
}
.ui-datepicker-header.ui-widget-header{
 background-color: {$colors['alter_bg_hover']}!important;
}
.ui-datepicker .ui-datepicker-title{
color: {$colors['text']};
}
/* Third-party plugins */


.xdsoft_datetimepicker {
	color: {$colors['text']};
}

.xdsoft_datetimepicker .xdsoft_calendar td, 
.xdsoft_datetimepicker .xdsoft_calendar th {
	color: {$colors['text']};
	background-color: transparent;
}

.xdsoft_datetimepicker .xdsoft_calendar td.xdsoft_default > div, 
.xdsoft_datetimepicker .xdsoft_calendar td.xdsoft_current > div, 
.xdsoft_datetimepicker .xdsoft_timepicker .xdsoft_time_box > div > div.xdsoft_current,
.xdsoft_datetimepicker .xdsoft_calendar td:hover >div, 
.xdsoft_datetimepicker .xdsoft_timepicker .xdsoft_time_box > div > div:hover {
	background-color: {$colors['text_hover']}!important;
	color: {$colors['inverse_text']}!important;
}

.xdsoft_datepicker {
     background-color: {$colors['alter_bg_hover']};
}


.mfp-bg {
	background-color: {$colors['bg_color_07']};
}
.mfp-image-holder .mfp-close,
.mfp-iframe-holder .mfp-close {
	color: {$colors['text_dark']};
}
.mfp-image-holder .mfp-close:hover,
.mfp-iframe-holder .mfp-close:hover {
	color: {$colors['text_link']};
}
.esg-grid i{
    color: {$colors['inverse_text']} !important;
}


/* Contact form 7 */
.scheme_self.contact_form_7.wpb_column > .vc_column-inner > .wpb_wrapper{
    background-color: {$colors['accent2']};
}
.wpcf7 label, .wpcf7 .wpcf7-list-item-label {
    color: {$colors['text_dark']};
}
.wpcf7 .select_container select, .wpcf7 input{
    background-color: {$colors['input_bg_color']}!important;
}
.wpcf7 input, .wpcf7 .select_container select{
    border-color: {$colors['input_bd_color']}!important;
}
.wpcf7 input::-webkit-input-placeholder{color: {$colors['input_bg_hover']};}
.wpcf7 input::-moz-placeholder{color: {$colors['input_bg_hover']};}
.wpcf7 input:-moz-placeholder{color: {$colors['input_bg_hover']};}
.wpcf7 input:-ms-input-placeholder{color: {$colors['input_bg_hover']};}

.wpcf7 .select_container select option{color: {$colors['input_bg_hover']};}
.wpcf7 .select_container select:focus, .wpcf7 .select_container select{color: {$colors['input_bg_hover']};}
.wpcf7 .select_container:after{
    color: {$colors['input_bg_hover']};
}
.wpcf7 .sc_item_button .sc_button_default2{
     background-color: {$colors['inverse_text']}!important;
     color: {$colors['text']}!important;
}
.wpcf7 .sc_item_button .sc_button_default2:hover{
     background-color: {$colors['text']}!important;
     color: {$colors['inverse_text']}!important;
}

.wp-block-button:not(.is-style-outline)>.wp-block-button__link:hover {
	background-color: {$colors['text_hover']}!important;
    color: {$colors['inverse_text']}!important;
}

.is-style-outline>.wp-block-button__link:not(.has-background):hover {
	border-color: {$colors['text_hover']}!important;
    color: {$colors['text_hover']}!important;
}

.wpcf7 form .wpcf7-response-output {
	color: {$colors['alter_dark']}!important;
}
.sc_popup button.mfp-close {
	background-color: transparent !important;
    color: {$colors['text_dark']}!important;
}
.sc_popup button.mfp-close:hover {
	background-color: transparent !important;
    color: {$colors['text_hover']}!important;
}

.wp-block-file__button {
	color: {$colors['inverse_text']};
}

CSS;
				
					$rez = apply_filters('wisemove_filter_get_css', $rez, $colors, false, $scheme);
					$css['colors'] .= $rez['colors'];
				}
			}
		}
				
		$css_str = (!empty($css['fonts']) ? $css['fonts'] : '')
				. (!empty($css['colors']) ? $css['colors'] : '');
		return apply_filters( 'wisemove_filter_prepare_css', $css_str, $remove_spaces );
	}
}
?>